"use strict";var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");require("../types/patch");

var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = require("@babel/traverse");
var _definitions = require("../types/definitions");

_definitions.MARKO_TYPES.forEach(typeName => {
  const checkKey = `is${typeName}`;
  const assertKey = `assert${typeName}`;
  const checkFn = t[checkKey];
  const assertFn = t[assertKey];
  _traverse.NodePath.prototype[checkKey] = function (opts) {
    return checkFn(this.node, opts);
  };
  _traverse.NodePath.prototype[assertKey] = function (opts) {
    assertFn(this.node, opts);
  };
});

_definitions.MARKO_ALIAS_TYPES.forEach(aliasName => {
  const checkKey = `is${aliasName}`;
  const originalProtoCheck = _traverse.NodePath.prototype[checkKey];
  _traverse.NodePath.prototype[checkKey] = function (opts) {
    return (
      t.is(aliasName, this.node, opts) ||
      originalProtoCheck.call(this, this.node, opts));

  };
});

const originalCrawl = _traverse.Scope.prototype.crawl;
_traverse.Scope.prototype.crawl = function () {
  const path = this.path;

  originalCrawl.apply(this, arguments);

  if (path.isMarkoTagBody()) {
    const params = path.parentPath.get("params");

    if (params.length) {
      for (const param of params) {
        this.registerBinding("param", param);
      }
    }
  }
};
//# sourceMappingURL=patch.js.map