"use strict";var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");exports.__esModule = true;exports.MARKO_ALIAS_TYPES = exports.MARKO_TYPES = exports.default = void 0;var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _utils = require("@babel/types/lib/definitions/utils");







var _core = require("@babel/types/lib/definitions/core");function ownKeys(object, enumerableOnly) {var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {return Object.getOwnPropertyDescriptor(object, sym).enumerable;});keys.push.apply(keys, symbols);}return keys;}function _objectSpread(target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {ownKeys(Object(source), true).forEach(function (key) {(0, _defineProperty2.default)(target, key, source[key]);});} else if (Object.getOwnPropertyDescriptors) {Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));} else {ownKeys(Object(source)).forEach(function (key) {Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));});}}return target;}
const valueFieldCommon = {
  value: {
    validate: (0, _utils.assertValueType)("string") } };



const MarkoDefinitions = {
  MarkoDocumentType: {
    aliases: ["Marko", "Statement"],
    builder: ["value"],
    visitor: ["value"],
    fields: _objectSpread({}, valueFieldCommon) },


  MarkoDeclaration: {
    aliases: ["Marko", "Statement"],
    builder: ["value"],
    visitor: ["value"],
    fields: _objectSpread({}, valueFieldCommon) },


  MarkoCDATA: {
    aliases: ["Marko", "Statement"],
    builder: ["value"],
    visitor: ["value"],
    fields: _objectSpread({}, valueFieldCommon) },


  MarkoComment: {
    aliases: ["Marko", "Statement"],
    builder: ["value"],
    visitor: ["value"],
    fields: _objectSpread({}, valueFieldCommon) },


  MarkoText: {
    aliases: ["Marko", "Statement"],
    builder: ["value"],
    visitor: ["value"],
    fields: _objectSpread({}, valueFieldCommon) },


  MarkoPlaceholder: {
    aliases: ["Marko", "Statement"],
    builder: ["value", "escape"],
    visitor: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertNodeType)("Expression") },

      escape: {
        validate: (0, _utils.assertValueType)("boolean"),
        default: true } } },




  MarkoScriptlet: {
    aliases: ["Marko", "Statement"],
    builder: ["body", "static"],
    visitor: ["body"],
    fields: {
      body: {
        validate: (0, _utils.arrayOfType)(["Statement"]) },

      static: {
        validate: (0, _utils.assertValueType)("boolean"),
        default: false } } },




  MarkoClass: {
    aliases: ["Marko", "Statement"],
    builder: ["body"],
    visitor: ["body"],
    fields: {
      body: {
        validate: (0, _utils.assertNodeType)("ClassBody") } } },




  MarkoAttribute: {
    aliases: ["Marko", "Expression"],
    builder: ["name", "value", "modifier", "arguments"],
    visitor: ["value", "arguments"],
    fields: {
      name: {
        validate: (0, _utils.assertValueType)("string") },

      value: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true },

      modifier: {
        validate: (0, _utils.assertValueType)("string"),
        optional: true },

      arguments: {
        validate: (0, _utils.chain)(
        (0, _utils.assertValueType)("array"),
        (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "SpreadElement"))),

        optional: true } } },




  MarkoSpreadAttribute: {
    aliases: ["Marko", "Expression"],
    builder: ["value"],
    visitor: ["value"],
    fields: {
      value: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true } } },




  MarkoTagBody: {
    aliases: ["Marko", "Block", "BlockParent", "Scope", "Scopable"],
    builder: ["body"],
    visitor: ["body"],
    fields: {
      body: {
        validate: (0, _utils.arrayOfType)([
        "MarkoTag",
        "MarkoCDATA",
        "MarkoText",
        "MarkoPlaceholder",
        "MarkoScriptlet",
        "MarkoComment"]),

        default: [] } } },




  MarkoTag: {
    aliases: ["Marko", "Statement"],
    builder: [
    "name",
    "attributes",
    "body",
    "params",
    "arguments",
    "properties",
    "runtimeFlags"],

    visitor: ["name", "attributes", "body", "params", "arguments"],
    fields: {
      name: {
        validate: (0, _utils.assertNodeType)("Expression") },

      attributes: {
        validate: (0, _utils.arrayOfType)(["MarkoAttribute", "MarkoSpreadAttribute"]),
        default: [] },

      body: {
        validate: (0, _utils.assertNodeType)("MarkoTagBody") },

      params: _objectSpread(_objectSpread({},
      _core.functionCommon.params), {}, {
        optional: true }),

      arguments: {
        validate: (0, _utils.chain)(
        (0, _utils.assertValueType)("array"),
        (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "SpreadElement"))),

        optional: true },

      properties: {
        validate: (0, _utils.arrayOfType)(["ObjectProperty"]),
        default: [] },

      handlers: {
        validate: (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression")),
        optional: true },

      rawValue: {
        validate: (0, _utils.assertValueType)("string"),
        optional: true },

      runtimeFlags: {
        validate: (0, _utils.assertValueType)("number"),
        default: 0 },

      key: {
        validate: (0, _utils.assertNodeType)("Expression"),
        optional: true } } } };var _default =





MarkoDefinitions;exports.default = _default;
const MARKO_TYPES = Object.keys(MarkoDefinitions);exports.MARKO_TYPES = MARKO_TYPES;
const MARKO_ALIAS_TYPES = Array.from(
new Set(
MARKO_TYPES.reduce((all, t) => all.concat(MarkoDefinitions[t].aliases), [])));exports.MARKO_ALIAS_TYPES = MARKO_ALIAS_TYPES;
//# sourceMappingURL=definitions.js.map